#!/bin/bash
#
# file name: flac2mp3_html.sh
# script to create a playlist of mp3 audio recordings within an html page.

# This is just a slightly modified version of the make_html.sh script that is part of FLAC-JACKET
# modified August 2007. Pete Nesbitt

############ HOW TO MODIFY THE HTML PAGE
# You can easily change the appearance of the html output file by editing
# the **CSS FILE ** named "flac2mp3.css". You may also want to edit 
# different sections of this file. The main assembly of all the html bits
# is the END SECTION of THIS FILE, look there to start.
# I think it's fairly well commented so it should be simple to modify.
############

#  ## IMPORTANT ##
# variables are in the rc file
# YOU WILL PROBABLY NEED TO EDIT THE FOLLOWING FILE:
. /data/scripts/flac2mp3/flac2mp3_html.rc

# New Vars (to make valid url):
HOST_NAME="cosmo.linux1.ca"
URL_PATH="http://${HOST_NAME}/mp3"


# get the directory listing into a file
# set each file line to be a url
##################################

# first enter each artists dir, then retreive each recording
cd $BASE_DIR
# for url
$LS -1  > $LIST_ARTISTS

## added Mar 2005 to add a bit of simple navigation (page is getting very long)
# get each artist name for top of page summary/links
$ECHO "<table border=0 cellpadding=6 width='100%'><tr>" > $ARTISTS_SUMMARY
COL="0"
while read ARTIST
 do
  # ignore: anything that is not a directory containing .mp3 files
  if [ -d $ARTIST ] && [ "`$LS -1 ${ARTIST}/|$GREP \"\.mp3$\"`" != "" ]; then
   COL=`$ECHO "$COL + 1"| $BC`
     if [ $COL -ge 4 ] ; then
       COL="1"
       $ECHO "</tr><tr>" >> $ARTISTS_SUMMARY
     fi

   $ECHO "<td><a href=#${ARTIST}>`$ECHO $ARTIST | $SED -e s/"_"/" "/g`</a></td>" >> $ARTISTS_SUMMARY
  fi
 done < $LIST_ARTISTS
$ECHO "</tr></table>" >> $ARTISTS_SUMMARY
# continue with page build
############


$ECHO "<table border=0 cellpadding=5><tr><td>" > $LIST_FILE
# enter each artist-dir and get album list (output 
while read ARTIST_NAME
 do
   # ignore: anything that is not a directory containing .mp3 files
   if [ -d $ARTIST_NAME ] && [ "`$LS -1 ${ARTIST_NAME}/|$GREP \"\.mp3$\"`" != "" ]; then
   cd $ARTIST_NAME
     # clear out any info saved from last artist
     $RM -f $LIST_SELECTION_BEG $LIST_SELECTION_END > /dev/null 2>&1
     $ECHO "<tr><td colspan=3>" >> $LIST_FILE
     # add a link from top artist list
     $ECHO "<a name=$ARTIST_NAME><hr></a><b><u>`$ECHO $ARTIST_NAME | $SED -e s/"_"/" "/g`</u></b><br>" >> $LIST_FILE
     $ECHO "</td></tr>" >> $LIST_FILE
     #work on each album tile. using ^ as a temp field separator, should be safe.
     $LS -1 *.mp3 | $AWK -F- '{print $2"^"$1}'| $SED -e s/"_"/"^"/|$AWK -F^ '{print $1"-"$3"-"$2}'|$SORT > $LIST_SELECTION_A
      #must adjust sort list so 00 to 20 are at end of list
      while read line
       do
         YEAR_BASE="`$EXPR \`$ECHO $line|$CUT -d- -f1\` \* 1`"
         if [ $YEAR_BASE -le 20 ]; then
            echo $line >> $LIST_SELECTION_END
         else
            echo $line >> $LIST_SELECTION_BEG
         fi
       done < $LIST_SELECTION_A
       $CAT $LIST_SELECTION_BEG $LIST_SELECTION_END 2>/dev/null |$AWK -F- '{print $2"-"$1"_"$3}' > $LIST_SELECTION 
     
       while read ALBUM
        do
          SHORT_NAME="${ALBUM%%.mp3}"
          SIDE_NUM=`$ECHO $SHORT_NAME | $AWK -F- '{print $2}' | $AWK -F_ '{print $2}'`
          YEAR=`$ECHO $SHORT_NAME | $AWK -F- '{print $2}' | $AWK -F_ '{print $1}'`
           #most likely century, if YEAR less than 20, use 2000, else 1900 (added May 2005)
           if [ $YEAR -le 20 ];then
              FULLYEAR="20${YEAR}"
           else
              FULLYEAR="19${YEAR}"
           fi
          TITLE=`$ECHO $SHORT_NAME | $AWK -F- '{print $1}'| $SED -e s/"_"/" "/g`
          REAL_SHORT="`$ECHO $SHORT_NAME|$AWK -F- '{print $1}'`"
          # get number if sides for that album
          $SED -e s/_[0-9].mp3$// $LIST_SELECTION > $LIST_SELECTION_TRIMMED
          NUM_SIDES="`$GREP -xc ^\$REAL_SHORT-[0-9][0-9] $LIST_SELECTION_TRIMMED`"
          #each album is caught once per side (could add a 5 & 6 for triple albums, but I don't have any:)
          if [ "$NUM_SIDES" -eq "4" ]; then 
             if [ "$SIDE_NUM" -eq "4" ]; then
               SIDE_4=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
               $ECHO "<tr><td>$TITLE</td><td>$FULLYEAR</td><td>$SIDE_1&nbsp;&nbsp;$SIDE_2&nbsp;&nbsp$SIDE_3&nbsp;&nbsp$SIDE_4</td></tr>" >> $LIST_FILE
              elif [ "$SIDE_NUM" -eq "3" ]; then
               SIDE_3=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
              elif [ "$SIDE_NUM" -eq "2" ]; then
               SIDE_2=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
              else
               SIDE_1=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
             fi
           elif [ "$NUM_SIDES" -eq "3" ]; then
             if [ "$SIDE_NUM" -eq "3" ]; then
               SIDE_3=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
               $ECHO "<tr><td>$TITLE</td><td>$FULLYEAR</td><td>$SIDE_1&nbsp;&nbsp$SIDE_2&nbsp;&nbsp$SIDE_3</td></tr>" >> $LIST_FILE
              elif [ "$SIDE_NUM" -eq "2" ]; then
               SIDE_2=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
              else
               SIDE_1=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
             fi
           elif [ "$NUM_SIDES" -eq "2" ]; then
             if [ "$SIDE_NUM" -eq "2" ]; then
               SIDE_2=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
               $ECHO "<tr><td>$TITLE</td><td>$FULLYEAR</td><td>$SIDE_1&nbsp;&nbsp$SIDE_2</td></tr>" >> $LIST_FILE
              else
               SIDE_1=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM </a>"`
             fi
           else
             SIDE_1=`$ECHO "<a href=${URL_PATH}/$ARTIST_NAME/$ALBUM>Side: $SIDE_NUM</a>"`
             $ECHO "<tr><td>$TITLE</td><td>$FULLYEAR</td><td>$SIDE_1</td></tr>" >> $LIST_FILE
          fi
        done < $LIST_SELECTION
     $ECHO "</td></tr>" >> $LIST_FILE
    # link to top of page
     $ECHO "<tr><td><a href=#top><font size=small>Top</font></a></td></tr>" >> $LIST_FILE
   cd $BASE_DIR
   fi
 done < $LIST_ARTISTS

$ECHO "</td></tr></table>" >> $LIST_FILE

##################################

# frame the contentas of the dir-file in html.
# you can edit the html below to customize your page


$ECHO "<html>"			>$WEB_LIST
$ECHO "<head>"			>>$WEB_LIST
$ECHO "<link rel=\"stylesheet\" type=\"text/css\" href=\"flac2mp3.css\" />"	>>$WEB_LIST
$ECHO "<title>"                 >>$WEB_LIST
$ECHO "My MP3 Album Collection" >>$WEB_LIST
$ECHO "</title>"                >>$WEB_LIST
$ECHO "</head>"                 >>$WEB_LIST
$ECHO ""			>>$WEB_LIST
$ECHO "<body>"  		>>$WEB_LIST
$ECHO "<a name=top>"  		>>$WEB_LIST
$ECHO "<font color=\"#fff9a6\"><font size=\"4\"><b>Pete's Albums</font>" >>$WEB_LIST
$ECHO "<br><font size=\"2\">...in mp3</b></font></font>"  >>$WEB_LIST
$ECHO "</a>"			>>$WEB_LIST
$ECHO "<br clear=left>"		>>$WEB_LIST
$ECHO "<a href=\"http://www.linux1.ca./index.shtml\"><font size=\"1\"><b>Back to Main Page</b></font></a>"	>>$WEB_LIST
$ECHO "<hr>"			>>$WEB_LIST
$ECHO "<u><font size=\"3\">Artists:</font></u><br>"	>>$WEB_LIST
$ECHO "`$CAT $ARTISTS_SUMMARY`" >>$WEB_LIST
$ECHO "<br><hr>"		>>$WEB_LIST
$ECHO "<u><b><font size=\"3\">Available Albums:</font></b></u>" >>$WEB_LIST
$ECHO "`$CAT $LIST_FILE`" 	>>$WEB_LIST
$ECHO "<br><hr><br>"		>>$WEB_LIST
$ECHO "<address><font size=\"2\">"	>>$WEB_LIST
$ECHO "<div align=left>" >>$WEB_LIST
$ECHO "<a href=\"http://www.linux1.ca./index.shtml\"><b>Back to Main Page</b></a>"      >>$WEB_LIST
$ECHO "</div>"			>>$WEB_LIST
$ECHO "<div align=right>" >>$WEB_LIST
$ECHO "From flac to raw to mp3 to the web. All done with: &nbsp;&nbsp;&nbsp; "	>>$WEB_LIST
$ECHO "<a href=\"http://www.linux1.ca\"><font color=\"#fff9a6\"><b>flac2mp3</b></font></a>&nbsp;&nbsp;"	>>$WEB_LIST
$ECHO "</div></font></address>"	>>$WEB_LIST
$ECHO "</body></html>"		>>$WEB_LIST

# clean up the "&" in any names or hrefs
$CAT $WEB_LIST |$SED "s/_\&_/_\&\#038\;_/g" > ${WEB_LIST}_1
$CAT ${WEB_LIST}_1|$SED "s/\ \&\ /\ \&\#038\;\ /g" > ${WEB_LIST}_2
$MV -f ${WEB_LIST}_2 $WEB_LIST
$RM -f ${WEB_LIST}_1

# end
